Module modGaiji
    Public oGaiji() As clsGaiji
    Public nGaijiCount As Integer
    Public nGaijiNameCount As Integer
    Public uGaijiCode() As GAIJI_CODE
    Public nGaijiCodeCount As Integer

    Public Structure DRCS
        Public NumberOfCode As Byte
        Public Pattern() As DRCS_PATTERN
    End Structure

    Public Structure DRCS_PATTERN
        Public CharacterCode As Integer
        'Public NumberOfFont As Byte
        Public Width As Byte
        Public Height As Byte
        Public patternData() As Byte
    End Structure

    Public Structure GAIJI_CODE
        Public CharacterCode As Integer
        Public GaijiNo As Integer
    End Structure

    Public Function GetDRCS(ByVal DA() As Byte, ByVal data_unit_size As Integer) As DRCS
        Dim uDRCS As DRCS
        Dim I, II, J As Integer

        With uDRCS
            .NumberOfCode = DA(0)
            ReDim .Pattern(.NumberOfCode)
            Dim size As Integer = (data_unit_size - 1) / .NumberOfCode
            For I = 0 To .NumberOfCode - 1
                II = size * I + 1
                With .Pattern(I)
                    .CharacterCode = DA(II) * &H100 + DA(II + 1)
                    .Width = DA(II + 5)
                    .Height = DA(II + 6)
                    Dim pat_size As Integer = CInt(.Width) * CInt(.Height) / 4
                    ReDim .patternData(pat_size - 1)
                    II = size * I + 8
                    For J = 0 To pat_size - 1
                        .patternData(J) = DA(II + J)
                    Next
                End With
            Next
        End With

        Return uDRCS
    End Function

    Public Function CheckPattern(ByVal pattern As DRCS_PATTERN) As Integer
        Dim sHash As String = GetMD5(pattern.patternData).ToUpper
        Dim I As Integer

        For I = 1 To nGaijiCount
            If oGaiji(I).Hash = sHash Then
                If oGaiji(I).Name = "" Then
                    nGaijiNameCount = nGaijiNameCount + 1
                    oGaiji(I).Name = "[O" & Format(nGaijiNameCount, "00") & "]"
                End If
                Return I
            End If
        Next

        ''---
        'Stop
        'Dim b As Byte
        'Dim result As New System.Text.StringBuilder
        'For Each b In pattern.patternData
        '    result.Append(b.ToString("x2"))
        'Next
        'Debug.WriteLine(result)
        ''---

        Return AddGaiji(pattern, sHash)


    End Function

    Public Function AddGaiji(ByVal pattern As DRCS_PATTERN, ByVal sHash As String) As Integer
        nGaijiCount = nGaijiCount + 1
        nGaijiNameCount = nGaijiNameCount + 1
        ReDim Preserve oGaiji(nGaijiCount)
        oGaiji(nGaijiCount) = New clsGaiji

        With oGaiji(nGaijiCount)
            .bOutput = True
            .Hash = sHash
            .Name = "[O" & Format(nGaijiNameCount, "00") & "]"
            .pic = GetGaijiPic(pattern)
            Try
                .pic.Save(GetAppPath() & "\Gaiji\" & .Hash & ".GIF", System.Drawing.Imaging.ImageFormat.Gif)
            Catch ex As Exception
                MsgBox(ex.ToString, MsgBoxStyle.Critical)    ' Show friendly error message
            End Try
        End With

        Return nGaijiCount
    End Function

    Public Function GetGaijiPic(ByVal pattern As DRCS_PATTERN) As Bitmap
        Dim pic As Bitmap = New Bitmap(pattern.Width, pattern.Height)
        pic = New Bitmap(pattern.Width, pattern.Height)
        Dim col01 As Color = Color.FromArgb(&HA0, &HA0, &HA0)
        Dim col10 As Color = Color.FromArgb(&H80, &H80, &H80)
        Dim col11 As Color = Color.FromArgb(0, 0, 0)

        'imgGraphicsIuWFNg擾
        Dim g As Graphics = Graphics.FromImage(pic)
        Dim x, y, I As Integer
        Dim s As String

        'ɓhԂ
        g.FillRectangle(Brushes.White, g.VisibleClipBounds)
        With pattern
            For y = 0 To .Height - 1
                'Debug.WriteLine("")
                For x = 0 To .Width / 4 - 1
                    s = Right("00000000" & (Convert.ToString(.patternData(y * .Width / 4 + x), 2)), 8)
                    'Debug.Write(s)
                    For I = 0 To 3
                        Select Case Strings.Mid(s, I * 2 + 1, 2)
                            Case "00"
                            Case "01"
                                pic.SetPixel(x * 4 + I, y, col01)
                            Case "10"
                                pic.SetPixel(x * 4 + I, y, col10)
                            Case "11"
                                pic.SetPixel(x * 4 + I, y, col11)
                        End Select
                    Next
                Next
            Next
        End With

        g.Dispose()

        Return pic
    End Function

    Public Function AddGaijiCode(ByVal oDU As clsDataUnit) As Integer
        Dim nCount As Integer
        Dim I As Integer
        Dim bExist As Boolean

        For nCount = 0 To oDU.NumberOfCode - 1
            bExist = False
            Dim nCode As Integer = oDU.CharacterCode(nCount)
            Dim GaijiNo As Integer = oDU.GaijiNo(nCount)
            For I = 1 To nGaijiCodeCount
                If uGaijiCode(I).CharacterCode = nCode Then
                    uGaijiCode(I).GaijiNo = GaijiNo
                    bExist = True
                End If
            Next

            If Not bExist Then
                nGaijiCodeCount = nGaijiCodeCount + 1
                ReDim Preserve uGaijiCode(nGaijiCodeCount)
                With uGaijiCode(nGaijiCodeCount)
                    .CharacterCode = nCode
                    .GaijiNo = GaijiNo
                End With
            End If
        Next
        Return nGaijiCodeCount
    End Function

    Public Function CheckGaijiCode(ByVal nCode As Integer) As Integer
        Dim I As Integer

        For I = 1 To nGaijiCodeCount
            If uGaijiCode(I).CharacterCode = nCode Then
                Return uGaijiCode(I).GaijiNo
            End If
        Next

        Return 0
    End Function

    Public Function GetGaiji(ByVal nCode As Integer) As String
        If oGaiji(CheckGaijiCode(nCode)) Is Nothing Then Return "" '07/08/14
        With oGaiji(CheckGaijiCode(nCode))
            If .bOutput Then
                If oGaiji(CheckGaijiCode(nCode)).Text = "" Then
                    Return oGaiji(CheckGaijiCode(nCode)).Name
                Else
                    Return oGaiji(CheckGaijiCode(nCode)).Text
                End If
            End If
            Return ""
        End With
    End Function

    Public Sub LoadGaiji()
        Try
            oIniDRCS = New cIni(GetAppPath() & "\Gaiji\cc_DRCS.ini")
            oIniDRCS.Section = "Op"
            Dim sText() As String = oIniDRCS.GetKeys()

            If sText Is Nothing Then Exit Sub

            Dim sKey() As String
            Dim sFile As String
            Dim I As Integer
            Dim nGaiji As Integer = UBound(sText)

            oIniDRCS.Section = "Oo"
            For I = 0 To nGaiji
                sKey = Split(sText(I), "=")

                nGaijiCount = nGaijiCount + 1
                ReDim Preserve oGaiji(nGaijiCount)
                oGaiji(nGaijiCount) = New clsGaiji

                With oGaiji(nGaijiCount)
                    .Hash = sKey(0)
                    .Text = sKey(1)
                    sFile = GetAppPath() & "\Gaiji\" & .Hash & ".gif"
                    If System.IO.File.Exists(sFile) Then
                        Dim bmpOld As Bitmap = New Bitmap(sFile)
                        Dim bmpNew As Bitmap = New Bitmap(bmpOld.Width, bmpOld.Height)
                        Dim g As Graphics = Graphics.FromImage(bmpNew)
                        g.DrawImage(bmpOld, 0, 0, bmpOld.Width, bmpOld.Height)
                        .pic = bmpNew
                    End If
                    .bOutput = Val(oIniDRCS.GetIniString(.Hash))
                End With
            Next
        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical)    ' Show friendly error message
        End Try

    End Sub

    Public Sub SaveGaiji()
        Try
            Dim I As Integer
            For I = 1 To nGaijiCount
                oIniDRCS.SetIniString("Op", oGaiji(I).Hash, oGaiji(I).Text)
                oIniDRCS.SetIniString("Oo", oGaiji(I).Hash, CInt(oGaiji(I).bOutput))
            Next
        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical)    ' Show friendly error message
        End Try

    End Sub
End Module
